%define libname libtet

Summary:       A Quality Tetrahedral Mesh Generator
Name:          tetgen
Version:       1.4.3
Release:       1
License:       MIT
Group:         Productivity/Scientific/Other
Source0:       %{name}%{version}.tar.gz
Patch0:        %{name}-%{version}-aix.patch
URL:           http://tetgen.berlios.de/
BuildRoot:     %{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
TetGen generates the Delaunay tetrahedralization, Voronoi diagram, constrained
Delaunay tetrahedralizations and quality tetrahedral meshes. The main goal of
TetGen is to generate suitable meshes for solving partial differential
equations by finite element or finite volume methods.


%package -n %{libname}
Summary:    The %{name} shared library
Group:      System/Libraries

%description -n %{libname}
This package contains the %{name} shared library


%package -n %{libname}-devel
Summary:    Development files for %{libname}
Group:      Development/Libraries/C and C++
Requires:   %{libname} = %{version}-%{release}

%description -n %{libname}-devel
The %{libname}-devel package contains libraries and header files for
developing applications that use %{libname}.


%prep 
%setup -q -n %{name}%{version}
%patch0
mkdir ../32bit
mv * ../32bit
mv ../32bit .
mkdir 64bit
cd 32bit && tar cf - . | (cd ../64bit ; tar xpf -)


%build
export CXX="xlC_r -O3 -qstrict"

cd 64bit
# first build the 64-bit version
export OBJECT_MODE=64
make tetgen tetlib
CreateExportList %{libname}.exp %{libname}.a
${CXX} -qmkshrobj %{libname}.a -o shr64.o -bE:%{libname}.exp -bernotok
rm -f %{libname}.exp %{libname}.a

cd ../32bit
# now build the 32-bit version
export OBJECT_MODE=32
make tetgen tetlib
CreateExportList %{libname}.exp %{libname}.a
${CXX} -qmkshrobj %{libname}.a -o shr.o -bE:%{libname}.exp -bernotok
rm -f %{libname}.exp %{libname}.a
/usr/bin/ar -X32 -rv %{libname}.a shr.o
/usr/bin/ar -X64 -q  %{libname}.a ../64bit/shr64.o


%install
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}

mkdir -p ${RPM_BUILD_ROOT}%{_bindir}
cp 32bit/tetgen ${RPM_BUILD_ROOT}%{_bindir}/
cp 64bit/tetgen ${RPM_BUILD_ROOT}%{_bindir}/tetgen_64
chmod 0755 ${RPM_BUILD_ROOT}%{_bindir}/*
/usr/bin/strip -X32_64 ${RPM_BUILD_ROOT}%{_bindir}/*

mkdir -p ${RPM_BUILD_ROOT}%{_libdir}
cp 32bit/%{libname}.a ${RPM_BUILD_ROOT}%{_libdir}/
chmod 0644 ${RPM_BUILD_ROOT}%{_libdir}/*

mkdir -p ${RPM_BUILD_ROOT}%{_includedir}
cp 32bit/*.h ${RPM_BUILD_ROOT}%{_includedir}/
chmod 0644 ${RPM_BUILD_ROOT}%{_includedir}/*

(
  cd ${RPM_BUILD_ROOT}
  for dir in bin include lib
  do
    mkdir -p usr/${dir}
    cd usr/${dir}
    ln -sf ../..%{_prefix}/${dir}/* .
    cd -
  done
)


%clean
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}


%files
%defattr(-,root,system,-)
%doc 32bit/LICENSE 32bit/README 32bit/example.poly
%{_bindir}/*
/usr/bin/*


%files -n %{libname}
%defattr(-,root,system,-)
%{_libdir}/*.a
/usr/lib/*.a


%files -n %{libname}-devel
%defattr(-,root,system,-)
%{_includedir}/*
/usr/include/*


%changelog
* Mon Mar 25 2013 Michael Perzl <michael@perzl.org> - 1.4.3-1
- first version for AIX V5.1 and higher
